import vlc, os, subprocess, threading, urllib2, random, time

class Player:
	def __init__(self, callback, xid):
		self.name = 'VLC-tvmx'
		self.callback = callback
		self.xid = xid
		self.mprunning = False

	def play(self, url):
		Instance = vlc.Instance()
		self.mp = vlc.MediaPlayer(Instance)
		self.mp.set_xwindow(self.xid)
		self.mp.video_set_mouse_input(False)
		self.mp.video_set_key_input(False)
		self.mp.set_mrl(url)
		self.mp.play()
		self.mprunning = True
		while self.mp.get_state() == vlc.State.Opening or self.mp.get_state() == vlc.State.NothingSpecial:
			time.sleep(0.1)
		if not self.mprunning:
			return
		self.callback()
		
	def pause(self):
		if hasattr(self, 'mp'):
			self.mp.pause()
	
	def stop(self):
		if hasattr(self, 'mp'):
			self.mp.stop()
			self.mprunning = False
			
	def volume(self, value):
		if hasattr(self, 'mp'):
			self.mp.audio_set_volume(int(value*100))
		
	def adjustImage(self, b, c, s):
		if hasattr(self, 'mp'):
			try:
				b = (float(b) + float(100)) / float(100)
				c = (float(c) + float(100)) / float(100)
				s = (float(s) + float(100)) / float(100)
				self.mp.video_set_adjust_int(vlc.VideoAdjustOption.Enable, True)
				self.mp.video_set_adjust_float(vlc.VideoAdjustOption.Brightness, b)
				self.mp.video_set_adjust_float(vlc.VideoAdjustOption.Contrast, c)
				self.mp.video_set_adjust_float(vlc.VideoAdjustOption.Saturation, s)
			except:
				pass
	
	def OSD(self, text):
		if hasattr(self, 'mp'):
			try:
				self.mp.video_set_marquee_int(vlc.VideoMarqueeOption.Enable, True)
				self.mp.video_set_marquee_string(vlc.VideoMarqueeOption.Text, text)
				self.mp.video_set_marquee_int(vlc.VideoMarqueeOption.Timeout, 4000)
			except:
				pass
		
	def setRatio(self, ratio):
		if ratio:
			if ratio == 1:
				ratio = '1:1'
			elif ratio == 1.5:
				ratio = '3:2'
			elif ratio == 1.33:
				ratio = '4:3'
			elif ratio == 1.25:
				ratio = '5:4'
			elif ratio == 1.55:
				ratio = '14:9'
			elif ratio == 1.4:
				ratio = '14:10'
			elif ratio == 1.77:
				ratio = '16:9'
			elif ratio == 1.6:
				ratio = '16:10'
			elif ratio == 2.35:
				ratio = '2.35:1'
		if hasattr(self, 'mp'):
			self.mp.video_set_aspect_ratio(ratio)
	
	def getStatus(self):
		if hasattr(self, 'mp'):
			if self.mp.get_state() == vlc.State.Error:
				return False
			return True
		else:
			return False

	def isPlaying(self):
		return self.mprunning
	
	def quit(self):
		self.mprunning = False
		try:
			if hasattr(self, 'mp'):
				self.mp.stop()
		except:
			pass