import threading, urllib2, time, datetime, re, itertools, gobject

class ProgramTV:
	def __init__(self):
		self.ghidTV = None
		self.guides = {}
     	
       	def getCurrent(self, channelName, callback):
	       	self.displayEPG = callback
	       	now = datetime.datetime.now()
		if now.hour < 6:
			today = datetime.date.today() - datetime.timedelta(1)
		else:
			today = datetime.date.today()
		zi = str(today.day)
		if len(zi) == 1:
			zi = '0' + zi
		luna = str(today.month)
		if len(luna) == 1:
			luna = '0' + luna
		an = str(today.year)
		datanoua = zi + '-' + luna + '-' + an
		if self.guides.has_key(channelName + '::' + datanoua):
			self.parseCurrent(self.guides[channelName + '::' + datanoua], channelName)
		else:
			threading.Thread(target=self.getGuideData, args=(datanoua, channelName, self.parseCurrent)).start()
		
	def parseCurrent(self, data, channelName):
		if not data:
			gobject.idle_add(self.displayEPG, None, None)
			return
		ore = []
		for x in data:
			ore.append(x[0])
		ore.sort()
		mimin = datetime.timedelta(seconds=-1)
		H = str(time.strftime("%H", time.localtime()))
		M = int(time.strftime("%M", time.localtime()))
		if M != 59:
			M = str(M+1)
		else:
			M = str(M)
		if len(M) == 1:
			M = '0' + M
		acum = datetime.datetime.strptime(H+':'+M , "%H:%M")
		try:
			apro = [x for x in itertools.takewhile( lambda t: acum > datetime.datetime.strptime(t, "%H:%M"), ore )][-1]
		except IndexError:
			gobject.idle_add(self.displayEPG, None, None)
			return
		for x in data:
			if x[0] == apro:
				gobject.idle_add(self.displayEPG, x[1], channelName)
	       
	def getGuideData(self, day, chname, callback):
		if self.guides.has_key(chname + '::' + day):
			gobject.idle_add(callback, self.guides[chname + '::' + day])
			return
		array = []
		try:
			req = urllib2.Request('http://tv.kappa.ro/' + chname + '/' + day)
			req.add_header("User-agent","Mozilla/5.0")
			response = urllib2.urlopen(req)
			data = response.read()
       			row = data.split('class="ora')
       			row.pop(0)
       			for x in row:
       				gd = x.split('</tr>')
       				rd = gd[0]
       				try:
	       				gl = rd.split('<a href="')
	       				gl2 = gl[1].split('" onclick="')
	       				link = gl2[0]
	       			except:
	       				link = '0'
       				rowdata = self.remove_extra_spaces(self.remove_html_tags(rd))
       				rowdata = rowdata.split('">')
       				rowdata = rowdata[1].split(' - ', 1)
       				now = datetime.datetime.strptime(rowdata[0], "%H:%M")
       				tdelta = datetime.timedelta(hours=-2)
       				newtime = now + tdelta
       				h = str(newtime.hour)
				m = str(newtime.minute)
				if len(h) == 1:
					h = '0' + h
				if len(m) == 1:
					m = '0' + m
       				new = h + ':' + m
       				rowdata[0] = self.toLocalTime(new)
       				rowdata.append(link)
       				array.append(rowdata)
       			self.guides[chname + '::' + day] = array
       			gobject.idle_add(callback, array)
       		except Exception, e:
       			gobject.idle_add(callback, None, None)
       			
       	def getPgDetails(self, url, callback):
	     	try:
	       		req = urllib2.Request(url + '?ajax=true&page=detalii_film')
	       		req.add_header("User-agent","Mozilla/5.0")
			res = urllib2.urlopen(req)
			data = res.read()
			gt = data.split('<div class="movie_title float_left">')
			gt = gt[1].split('<span class="movie_date">')
			title = gt[0]
			title = self.remove_extra_spaces(title).replace(' , ', '')
			cont = data.split('<div class="cls_15">')
			cont = cont[1]
			if '<img src="' in cont:
				gim = cont.split('<img src="')
				gim = gim[1].split('" border="0"')
				gim = gim[0]
		       		req = urllib2.Request(gim)
		       		req.add_header("User-agent","Mozilla/5.0")
				getimg = urllib2.urlopen(req)
				image = getimg.read()
			else:
				image = None
			gs = cont.split('<td valign="top" align="justify">')
			gs = gs[1].split('</tr>')
			sidenote = gs[0].replace('<b>','BOLD[')
			sidenote = sidenote.replace('</b>', ']BOLD')
			sidenote = sidenote.replace('<br />', '[BR]')
			sidenote = sidenote.replace('&nbsp;', ' ')
			sidenote = self.remove_extra_spaces(self.remove_html_tags(sidenote))
			sidenote = sidenote.replace(']BOLD', '</b>')
			sidenote = sidenote.replace('BOLD[', '<b>')
			if image:
				gd = cont.split('<td colspan="2" align="justify">')
			else:
				gd = cont.split('<td align="justify">')
			gd = gd[1].split('</td>')
			detalii = gd[0].replace('<BR>', '\n')
			detalii = self.remove_extra_spaces(self.remove_html_tags(detalii))[1:]
			gobject.idle_add(callback, [image, title, sidenote, detalii], url)
		except Exception, e:
			gobject.idle_add(callback, None, url)
       	
       	def remove_html_tags(self, data):
		p = re.compile(r'<.*?>')
		return p.sub('', data)
		
	def remove_extra_spaces(self, data):
		p = re.compile(r'\s+')
		return p.sub(' ', data)
		
	def toLocalTime(self, hour):
		diff = time.timezone
		diff = -diff
		now = datetime.datetime.strptime(hour, "%H:%M")
		delta = datetime.timedelta(seconds=diff)
		newtime = now + delta
		h = str(newtime.hour)
		m = str(newtime.minute)
		if len(h) == 1:
			h = '0' + h
		if len(m) == 1:
			m = '0' + m
		return h + ':' + m
