import gtk

class RadioWidget:
	def __init__(self, outer):
		self.gui = outer.gui
		self.tvmaxe = outer
		self.currentIter = None
		
	def modRadio(self, obj):
		self.buildMenu()
		self.tvmaxe.radioMode = True
		self.gui.get_object('notebook2').set_current_page(1)
		self.gui.get_object('window1').hide()
		self.gui.get_object('window13').show()
		self.gui.get_object('menuitem39').hide()
		
	def modTV(self, obj, event=None):
		self.tvmaxe.radioMode = False
		self.gui.get_object('window1').show()
		self.gui.get_object('window13').hide()
		self.gui.get_object('menuitem39').show()
		return True
	
	def updateWidget(self, name, url, logo):
		self.gui.get_object('label81').set_label(name)
		self.gui.get_object('label82').set_label(url)
		self.gui.get_object('image25').set_from_pixbuf(logo)
	
	def buildMenu(self):
		model = self.gui.get_object('treestore3')
		menu = gtk.Menu()
		iter = model.get_iter_root()
		while iter:
			#treeselection.select_iter(iter)
			#selected = treeselection.get_selected()
			nume = model.get_value(iter, 1)
			item = gtk.MenuItem(nume)
			item.show()
			item.connect("activate", self.tvmaxe.trayplay, self.tvmaxe.playRadioChannel, (model, iter))
			menu.append(item)
			iter = model.iter_next(iter)
		self.gui.get_object('menuitem41').remove_submenu()
		self.gui.get_object('menuitem41').set_submenu(menu)
	
	def play(self, obj, t):
		self.tvmaxe.playRadioChannel(t)
