#!/usr/bin/python
#-*- coding: utf-8 -*-

version = 0.07
basehost = 'http://www.pymaxe.com/tvmaxe/'

import gettext, locale, gtk.glade
GETTEXT_DOMAIN = 'tvmaxe'
try:
	LOCALE_PATH = os.path.join(os.path.dirname(os.path.abspath( __file__ )), 'lng')
except:
	LOCALE_PATH = 'lng'
locale.setlocale(locale.LC_ALL, '')
for module in gtk.glade, gettext:
	module.bindtextdomain(GETTEXT_DOMAIN, LOCALE_PATH)
	module.textdomain(GETTEXT_DOMAIN)
	
def translate(text):
	text = unicode(text, errors='ignore')
	try:
		return unicode(gettext.gettext(text), errors='ignore')
	except:
		return gettext.gettext(text)

import __builtin__
__builtin__._ = translate

import os, sys
#os.chdir('/usr/share/tvmaxe')
import pygtk, gobject
pygtk.require('2.0')
import gtk
import subprocess, threading, urllib2, workerpool, random, time, datetime, webbrowser, string
import irwatch, which
from settingsManager import settingsManager
from programTV import *
from tvmlist import ListParser
from pbx import PBX
from iconDownloader import IconDownloader
from radioWidget import RadioWidget
import remoteC
gtk.gdk.threads_init()

class Main:
	def __init__(self):
        	self.gui = gtk.Builder()
        	self.gui.add_from_file('tvmaxe.glade')
        	self.settingsManager = settingsManager(self)
        	self.radioWidget = RadioWidget(self)
        	self.HTTPremote = remoteC.HTTPRemoteControl(self.getChannelList, self.playURL)
        	self.gui.connect_signals({"on_imagemenuitem5_activate" : self.quit,
        				  "on_window1_delete_event" : self.quit,
        				  "listPress" : self.listPress,
        				  "radioListPress" : self.radioListPress,
        				  "fullscreen" : self.fullscreen,
        				  "playpause" : self.playpause,
        				  "stop" : self.stop,
        				  "hideCursor" : self.hideCursor,
        				  "setVolume" : self.setVolume,
        				  "mainWindowsKeyRelease" : self.mainWindowsKeyRelease,
        				  "show_settings" : self.settingsManager.showGUI,
        				  "hide_settings" : self.settingsManager.hideGUI,
        				  "save_settings" : self.settingsManager.Save,
        				  "toggleInternalPlayer" : self.settingsManager.toggleInternalPlayer,
        				  "toggleExternalPlayer" : self.settingsManager.toggleExternalPlayer,
        				  "toggleStaticPorts" : self.settingsManager.toggleStaticPorts,
        				  "toggleEnableRemote" : self.settingsManager.toggleEnableRemote,
        				  "toggleEnableHTTP" : self.settingsManager.toggleEnableHTTP,
        				  "toggleStatusIcon" : self.settingsManager.toggleStatusIcon,
        				  "mapRemote" : self.settingsManager.mapRemote,
        				  "hideIR" : self.settingsManager.hideIR,
        				  "toggleAbonament" : self.settingsManager.toggleAbonament,
        				  "channelList" : self.channelList,
        				  "showGhidTV" : self.showGhidTV,
        				  "hideGhidTV" : self.hideGhidTV,
        				  "pgDetails" : self.pgDetails,
        				  "updateEPG" : self.updateEPG,
        				  "drawLogo" : self.drawLogo,
        				  "showAbout" : self.showAbout,
        				  "hideAbout" : self.hideAbout,
        				  "aspectRatio" : self.aspectRatio,
        				  "mouseRemote" : self.mouseRemote,
        				  "ShowDetails" : self.ShowDetails,
        				  "hideShowDetails" : self.hideShowDetails,
        				  "refreshList" : self.refreshList,
        				  "showAddStream" : self.showAddStream,
        				  "hideAddStream" : self.hideAddStream,
        				  "tabSwitch" : self.tabSwitch,
        				  "addNewChannel" : self.addNewChannel,
        				  "deleteChannel" : self.deleteChannel,
        				  "showVideoEQ" : self.showVideoEQ,
        				  "applyContrast" : self.applyContrast,
        				  "hideVideoEQ" : self.hideVideoEQ,
        				  "videoEQreset" : self.videoEQreset,
        				  "saveContrast" : self.saveContrast,
        				  "loginPBX" : self.loginPBX,
        				  "hidePBX" : self.hidePBX,
        				  "connectPBX" : self.connectPBX,
        				  "wrapDonateText" : self.wrapDonateText,
        				  "donate" : self.donate,
        				  "donated" : self.donated,
        				  "adaugaAbonament" : self.adaugaAbonament,
        				  "hideAdaugaAbonament" : self.hideAdaugaAbonament,
        				  "addSubscription" : self.addSubscription,
        				  "editAbonament" : self.editAbonament,
        				  "hideEditAbonament" : self.hideEditAbonament,
        				  "stergeAbonament" : self.stergeAbonament,
        				  "saveEditAbonament" : self.saveEditAbonament,
        				  "hideShowTVMaxe" : self.hideShowTVMaxe,
        				  "hideShowTVMaxe_Menu" : self.hideShowTVMaxe_Menu,
        				  "channelInfo" : self.channelInfo,
        				  "hideChannelInfo" : self.hideChannelInfo,
        				  "channelInfo_showGhidTV" : self.channelInfo_showGhidTV,
        				  "channelInfo_raporteaza" : self.channelInfo_raporteaza,
        				  "statusIconVolume" : self.statusIconVolume,
        				  "modRadio" : self.radioWidget.modRadio,
        				  "modTV" : self.radioWidget.modTV,
        				  "prevChannel" : self.prevChannel,
        				  "nextChannel" : self.nextChannel,
        				  "hideError" : self.hideError
        	})
        	
        	drawingarea = self.gui.get_object('drawingarea1')
        	drawingarea.modify_bg(gtk.STATE_NORMAL, drawingarea.get_colormap().alloc_color("black"))
        	self.gui.get_object('eventbox1').modify_bg(gtk.STATE_NORMAL, self.gui.get_object('eventbox1').get_colormap().alloc_color("black"))
        	self.statusbar(_('Ready'))

        	if not self.settingsManager.internal:
        		self.gui.get_object('vbox2').hide()
        		self.gui.get_object('checkmenuitem1').set_sensitive(False)
        		self.gui.get_object('menuitem7').set_sensitive(False)
        	        	
        	self.accel_group = gtk.AccelGroup()
		self.gui.get_object('window1').add_accel_group(self.accel_group)
		self.gui.get_object('checkmenuitem1').add_accelerator("activate", self.accel_group, ord("F"), gtk.gdk.CONTROL_MASK, gtk.ACCEL_VISIBLE)
		self.gui.get_object('menuitem7').add_accelerator("activate", self.accel_group, ord("H"), gtk.gdk.CONTROL_MASK, gtk.ACCEL_VISIBLE)
		self.combobox2h = None
		self.combobox3h = None
		self.hideTimeout = None
		self.lastIter = None
		self.radioMode = False
		self.tvmaxevis = True
		self.sLock = False
		self.name = None
		self.logo = 'logo.jpg'
		self.abonamente = self.settingsManager.subscriptions
		wsize = self.settingsManager.getWindowSize()
		self.gui.get_object('window1').resize(wsize[0], wsize[1])
		hpaned = self.settingsManager.getHPanedPosition()
		self.gui.get_object('hpaned1').set_position(hpaned)
		self.gui.get_object('statusicon1').set_visible(self.settingsManager.getStatusIcon())
		
        	self.gui.get_object('window1').show()
        	self.gui.get_object('treeviewcolumn2').clicked()
		self.gui.get_object('treeviewcolumn6').clicked()
        	        	
        	self.tvguide = ProgramTV()
        	self.pbx = PBX()
        	self.showDonate()
        	self.setupProtocols()
        	self.setupPlayers()
        	self.gui.get_object('treestore2').clear()
		self.gui.get_object('treestore3').clear()
        	threading.Thread(target=self.getChannels, args=(self.populateList,)).start()
        	self.initPlayer()
        	gobject.timeout_add(500, self.drawLogo)
        
        def setupProtocols(self):
		self.protocols = {}
		protocols_dir = os.getcwd() + '/protocols/'
		sys.path.append(protocols_dir)
		files = os.listdir(protocols_dir)
		for x in files:
			p = protocols_dir + x
			if not os.path.isdir(p):
				if x.endswith('.py'):
					x = os.path.splitext(x)
					x = x[0]
					try:
						loadmod = __import__(x)
						self.protocols[x] = loadmod.Protocol(self.play, self.stop, '')
					except:
						pass
        
        def setupPlayers(self):
		self.players = {}
		liststore = self.gui.get_object('liststore2')
		drawable = self.gui.get_object('drawingarea1')
		xid = drawable.window.xid
		players_dir = os.getcwd() + '/players/'
		sys.path.append(players_dir)
		files = os.listdir(players_dir)
		for x in files:
			modul = players_dir + x
			if not os.path.isdir(modul):
				if x.endswith('.py'):
					x = os.path.splitext(x)
					x = x[0]
					loadmod = __import__(x)
					try:
						self.players[x] = loadmod.Player(self.playCallback, xid)
						liststore.append([self.players[x].name])
					except Exception, e:
						print e
					
		backend = self.settingsManager.backend
		if self.settingsManager.internal:
			try:
				self.mediaPlayer = self.players[backend.lower()]
			except Exception, e:
				self.mediaPlayer = self.players['mplayer']
		else:
			self.mediaPlayer = None #yet
		
        def initPlayer(self):
        	self.isFullscreen = False
        	self.paused = False
        	self.cursorTimeout = None
        	
        	if self.settingsManager.enableremote:
			self.initRemote()
		if self.settingsManager.enablehttpremote:
			self.HTTPremote.start(int(float(self.settingsManager.remoteport)))
        	self.gui.get_object('volumebutton1').set_value(self.settingsManager.volume)
        	self.gui.get_object('volumebutton2').set_value(self.settingsManager.volume)
        	self.setContrast()
        	
	       	self.setupRatio()
	       	
	def setupRatio(self):
		if self.settingsManager.aspectratio == '1:1':
        		self.gui.get_object('menuitem22').set_active(True)
        	elif self.settingsManager.aspectratio == '3:2':
        		self.gui.get_object('menuitem23').set_active(True)
        	elif self.settingsManager.aspectratio == '4:3':
        		self.gui.get_object('radiomenuitem2').set_active(True)
        	elif self.settingsManager.aspectratio == '5:4':
        		self.gui.get_object('menuitem24').set_active(True)
        	elif self.settingsManager.aspectratio == '14:9':
        		self.gui.get_object('menuitem25').set_active(True)
        	elif self.settingsManager.aspectratio == '14:10':
        		self.gui.get_object('menuitem26').set_active(True)
        	elif self.settingsManager.aspectratio == '16:9':
        		self.gui.get_object('menuitem11').set_active(True)
        	elif self.settingsManager.aspectratio == '16:10':
        		self.gui.get_object('menuitem27').set_active(True)
        	elif self.settingsManager.aspectratio == '2.35:1':
        		self.gui.get_object('menuitem26').set_active(True)
        	
        def drawLogo(self, obj=None, event=None):
		if hasattr(self, 'mediaPlayer'):
			if self.mediaPlayer.mprunning:
				return True
		drawingarea = self.gui.get_object('drawingarea1')
		if drawingarea.window:
			x, y, width, height = drawingarea.get_allocation()
			pixbuf = gtk.gdk.pixbuf_new_from_file(self.logo)
			pixbuf = pixbuf.scale_simple(width, height, gtk.gdk.INTERP_NEAREST)
			gc = drawingarea.window.new_gc()
			tmout = gobject.timeout_add(110, drawingarea.window.draw_pixbuf, gc, pixbuf, 0, 0, 0, 0, -1, -1, gtk.gdk.RGB_DITHER_NONE, 0, 0)
			#pixmap, mask = pixbuf.render_pixmap_and_mask()
			#gobject.idle_add(drawingarea.window.set_back_pixmap, pixmap, False)
		return True
        	
        def initRemote(self):
        		self.infrared = irwatch.IRwatch()
			self.infrared.callbacks.append(self.receiveIR)
			threading.Thread(target=self.infrared.listen).start()
	
	def receiveIR(self, code):
		if code == self.settingsManager.remote_playpause:
			gobject.idle_add(self.playpause, None)
		if code == self.settingsManager.remote_switch_fullscreen:
			gobject.idle_add(self.fullscreen, None)
		if code == self.settingsManager.remote_stop:
			gobject.idle_add(self.stop, None)
		if code == self.settingsManager.remote_volumeup:
			gobject.idle_add(self.setVolume, None, None, 0.1)
		if code == self.settingsManager.remote_volumedown:
			gobject.idle_add(self.setVolume, None, None, -0.1)
		if code == self.settingsManager.remote_mute:
			gobject.idle_add(self.mute)
		if code == self.settingsManager.remote_quit:
			gobject.idle_add(self.quit, None)
		if code == self.settingsManager.remote_nextchannel:
			gobject.idle_add(self.nextChannel)
		if code == self.settingsManager.remote_prevchannel:
			gobject.idle_add(self.prevChannel)
		if code == self.settingsManager.remote_info:
			gobject.idle_add(self.showEPG)
		if code == self.settingsManager.remote_up:
			gobject.idle_add(self.remoteUP)
		if code == self.settingsManager.remote_down:
			gobject.idle_add(self.remoteDOWN)
		if code == self.settingsManager.remote_ok:
			gobject.idle_add(self.remoteOK)
		
	def stopRemote(self):
		try:
			self.infrared.callbacks.pop(self.infrared.callbacks.index(self.receiveIR))
		except:
			pass
		self.infrared.quit()
	
        def getChannels(self, callback):
        	try:
			pbxlogin = self.settingsManager.getPBXuser()
			if pbxlogin[0]:
				self.pbx.working = False
				gobject.idle_add(self.loginPBX, None, True)
		except Exception, e:
			print e
		blacklist = self.settingsManager.getBlacklist()
		gobject.idle_add(self.loadUserList, blacklist)
		for x in self.abonamente:
			if x != 'local://' and x != '':
				savefile = x.replace("http://", "")
				savefile = savefile.replace("/", "")
				savefile = os.getenv('HOME') + '/.tvmaxe/' + savefile
				try:
					if os.path.exists(savefile):
						fh = open(savefile, "r")
						data = fh.read()
						fh.close()
						abonament = self.findKey(self.settingsManager.abonamente, x)
						gobject.idle_add(callback, data, abonament)
					else:
							print "Retrieving ", x
					req = urllib2.Request(x)
					response = urllib2.urlopen(req)
					data = response.read()
					fh = open(savefile, "w")
					fh.write(data)
					fh.close()
					abonament = self.findKey(self.settingsManager.abonamente, x)
					gobject.idle_add(callback, data, abonament)
				except Exception, e:
					print e
					gobject.idle_add(self.listError)
					return
					
	def loadUserList(self, blacklist):
		if 'local://' in self.abonamente:
			try:
				chfile = open(os.getenv('HOME') + '/.tvmaxe/tvmaxe_ch', 'r')
				image = gtk.gdk.pixbuf_new_from_file('blank.gif')
				for x in chfile.readlines():
					chdata = x.split('|-|')
					if not chdata[2][:-1].translate(string.maketrans("", ""), string.whitespace) in blacklist:
						if chdata[0] == 'TV':
							channelstore = self.gui.get_object('treestore2')
							channelstore.append(None, [image, chdata[1], chdata[2][:-1], '', 'Local'])
						elif chdata[0] == 'RA':
							channelstore = self.gui.get_object('treestore3')
							channelstore.append(None, [image, chdata[1], chdata[2][:-1], 'Local'])
			except Exception, e:
				print _("Cannot read user's channel list")
        	
        def populateList(self, data, abonament):
        	blacklist = self.settingsManager.getBlacklist()
        	self.pool = workerpool.WorkerPool(size=10)
        	if '|tvchannels|' in data:
	        	gtvch = data.split('|tvchannels|')
        		gtvch = gtvch[1].split('|endoftvchannels|')
        		channels = gtvch[0]
        		channels = channels.split('|newchannel|')
	        	channels.pop(0)
			channelstore = self.gui.get_object('treestore2')
			for x in channels:
				cdata = x.split('|-|')
				nume = cdata[0]
				url = cdata[1]
				icon = cdata[2]
				if len(cdata) > 3:
					chid = cdata[3]
				else:
					chid = ''
				image = gtk.gdk.pixbuf_new_from_file('blank.gif')
				if not url.translate(string.maketrans("", ""), string.whitespace) in blacklist:
					if not self.channelExists(url.translate(string.maketrans("", ""), string.whitespace), nume, channelstore):
						if self.protocolCheck(url):
							iter = channelstore.append(None, [image, nume, url, chid, abonament])
							threading.Thread(target=self.updateIcon, args=(iter, icon, channelstore)).start()

		if '|radiochannels|' in data:
			grch = data.split('|radiochannels|')
        		grch = grch[1].split('|endofradiochannels|')
        		channels = grch[0]
			channels = channels.split('|newchannel|')
	        	channels.pop(0)
			channelstore = self.gui.get_object('treestore3')
			for x in channels:
				cdata = x.split('|-|')
				nume = cdata[0]
				url = cdata[1]
				icon = cdata[2]
				image = gtk.gdk.pixbuf_new_from_file('blank.gif')
				if not url in blacklist:
					if not self.channelExists(url.translate(string.maketrans("", ""), string.whitespace), nume, channelstore):
						if self.protocolCheck(url):
							iter = channelstore.append(None, [image, nume, url, abonament])
							threading.Thread(target=self.updateIcon, args=(iter, icon, channelstore)).start()

			self.createTrayMenus()
        		
        def updateIcon(self, iter, imageurl, channelstore):
        	job = IconDownloader(basehost, iter, imageurl, channelstore, self.setIcon)
        	self.pool.put(job)
        	
        def setIcon(self, iter, imgdata, channelstore):
        	loader = gtk.gdk.PixbufLoader()
        	loader.write(imgdata)
        	loader.close()
        	channelstore.set_value(iter, 0, loader.get_pixbuf())
        	
        def protocolCheck(self, url):
        	toReturn = False
        	for x in self.protocols:
			for y in self.protocols[x].protocols:
				if url.startswith(y):
					toReturn = True
		return toReturn
		
	def getProtocol(self, url):
        	for x in self.protocols:
			for y in self.protocols[x].protocols:
				if url.startswith(y):
					return self.protocols[x]
		return None
        
        def listPress(self, obj, event):
        	self.gui.get_object('treeview3').get_selection().unselect_all()
        	if hasattr(event, 'button'):
			self.gui.get_object('vbox18').hide()
			if event.button == 1 and event.type == gtk.gdk._2BUTTON_PRESS:
				chList = self.gui.get_object('treeview1')
				treeselection = chList.get_selection()
				selected = treeselection.get_selected()
				threading.Thread(target=self.playChannel, args=(selected,)).start()
				self.gui.get_object('modradiomenu').set_sensitive(False)
			if event.button == 3:
				x = int(event.x)
				y = int(event.y)
				pthinfo = obj.get_path_at_pos(x, y)
				if pthinfo is not None:
					path, col, cellx, celly = pthinfo
					obj.grab_focus()
					obj.set_cursor( path, col, 0)
					treeselection = obj.get_selection()
					(model, iter) = treeselection.get_selected()
					url = model.get_value(iter, 2);
					if url != '':
						chid = model.get_value(iter, 3);
						if chid != '':
							self.gui.get_object('menuitem6').set_sensitive(True)
						else:
							self.gui.get_object('menuitem6').set_sensitive(False)
						self.gui.get_object('menu4').popup(None, None, None, event.button, event.time)
		elif hasattr(event, 'keyval'):
			if event.keyval == 65293:
				chList = self.gui.get_object('treeview1')
				treeselection = chList.get_selection()
				selected = treeselection.get_selected()
				threading.Thread(target=self.playChannel, args=(selected,)).start()
	
	def radioListPress(self, obj, event):
		self.gui.get_object('treeview1').get_selection().unselect_all()
		if hasattr(event, 'button'):
			self.gui.get_object('vbox18').hide()
			if event.button == 1 and event.type == gtk.gdk._2BUTTON_PRESS:
				chList = self.gui.get_object('treeview3')
				treeselection = chList.get_selection()
				selected = treeselection.get_selected()
				threading.Thread(target=self.playRadioChannel, args=(selected,)).start()
			if event.button == 3:
				x = int(event.x)
				y = int(event.y)
				pthinfo = obj.get_path_at_pos(x, y)
				if pthinfo is not None:
					path, col, cellx, celly = pthinfo
					obj.grab_focus()
					obj.set_cursor( path, col, 0)
					treeselection = obj.get_selection()
					(model, iter) = treeselection.get_selected()
					url = model.get_value(iter, 2);
					if url != '':
						self.gui.get_object('menuitem6').set_sensitive(False)
						self.gui.get_object('menu4').popup(None, None, None, event.button, event.time)
		elif hasattr(event, 'keyval'):
			if event.keyval == 65293:
				chList = self.gui.get_object('treeview3')
				treeselection = chList.get_selection()
				selected = treeselection.get_selected()
				threading.Thread(target=self.playRadioChannel, args=(selected,)).start()
				
        def playChannel(self, selected):
        	self.stop(None)
        	time.sleep(1)
        	if selected[1]:
			self.url = selected[0].get_value(selected[1], 2);
			self.name = selected[0].get_value(selected[1], 1);
			self.chid = selected[0].get_value(selected[1], 3);
			if self.url != '':
				self.logo = 'incarca.jpg'
				gobject.idle_add(self.statusbar, _('Loading ') + self.name)
				gobject.idle_add(self.modradiomenuStatus, 'tv')
				protocol = self.getProtocol(self.url)
				protocol.play(self.url)
				gobject.timeout_add(400, self.updateProgressbar, protocol)
	
	def playRadioChannel(self, selected):
        	self.stop(None)
        	time.sleep(1)
        	if selected[1]:
			self.url = selected[0].get_value(selected[1], 2);
			self.name = selected[0].get_value(selected[1], 1);
			self.chid = '';
			if self.url != '':
				self.logo = 'incarca.jpg'
				gobject.idle_add(self.radioWidget.updateWidget, self.name, self.url, selected[0].get_value(selected[1], 0))
				gobject.idle_add(self.modradiomenuStatus, 'radio')
				if self.url.endswith('.pls') or self.url.endswith('.m3u') :
					self.url = ListParser().getData(self.url)
				protocol = self.getProtocol(self.url)
				protocol.play(self.url)
				gobject.timeout_add(400, self.updateProgressbar, protocol)
					
	def playURL(self, url):
		self.stop(None)
        	time.sleep(1)
        	if not '://' in url:		# making a base check if the protocol has been specified
			self.url = 'http://' + url   # we suppose that the user wants to play a HTTP stream...
		else:
			self.url = url
		self.name = self.url
		# Try to find if the address already exists in list
		select = None
		if not select:
			model = self.gui.get_object('treestore2')
			iter = model.get_iter_root()
			while iter:
				my_url = model.get_value(iter, 2)
				if url == my_url:
					self.name = model.get_value(iter, 1)
					chList = self.gui.get_object('treeview1')
					treeselection = chList.get_selection()
					treeselection.select_iter(iter)
					select = 'tv'
					break
				iter = model.iter_next(iter)
		if not select:
			model = self.gui.get_object('treestore3')
			iter = model.get_iter_root()
			while iter:
				my_url = model.get_value(iter, 2)
				if url == my_url:
					self.name = model.get_value(iter, 1)
					chList = self.gui.get_object('treeview3')
					treeselection = chList.get_selection()
					treeselection.select_iter(iter)
					select = 'radio'
					break
				iter = model.iter_next(iter)
		if select == 'tv':
			chList = self.gui.get_object('treeview1')
			treeselection = chList.get_selection()
			selected = treeselection.get_selected()
			print 'playChannel'
			self.playChannel(selected)
		elif select == 'radio':
			chList = self.gui.get_object('treeview3')
			treeselection = chList.get_selection()
			selected = treeselection.get_selected()
			self.playRadioChannel(selected)
		else:
			if self.url != '':
				self.logo = 'incarca.jpg'
				gobject.idle_add(self.statusbar, _('Loading ') + self.name)
				gobject.idle_add(self.modradiomenuStatus, 'tv')
				protocol = self.getProtocol(self.url)
				protocol.play(self.url)
				gobject.timeout_add(400, self.updateProgressbar, protocol)
				
	def play(self, url):
		self.mediaPlayer.play(url)
			
	def modradiomenuStatus(self, t):
		if t == 'tv':
			self.gui.get_object('modradiomenu').set_sensitive(False)
		elif t == 'radio':
			if self.settingsManager.getInternal():
				self.gui.get_object('modradiomenu').set_sensitive(True)
				
        def stop(self, error=None):
		if type(error) == str:
			self.stopCallback()
			self.logo = 'error.jpg'
			for x in self.protocols:
				self.protocols[x].stop()
			return
		for x in self.protocols:
			self.protocols[x].stop()
		self.stopCallback()
        	
        def playCallback(self):
		self.gui.get_object('label65').set_text(_("Playing: ") + self.name)
        	self.gui.get_object('image1').set_from_stock(gtk.STOCK_MEDIA_PAUSE, gtk.ICON_SIZE_BUTTON)
        	self.mediaPlayer.volume(self.gui.get_object('volumebutton1').get_value())
        	self.setupRatio()
        	self.initialTime = int(time.time()) # pentru functia initContrast
        	gobject.timeout_add(50, self.initContrast)
        	gobject.timeout_add(2000, self.showEPG)
        	self.gtime = True
        	threading.Thread(target=self.getTime).start()
        	try:
			drawingarea = self.gui.get_object('drawingarea1')
			gobject.timeout_add(200, drawingarea.modify_bg, gtk.STATE_NORMAL, drawingarea.get_colormap().alloc_color("black"))
		except:
			pass
		protocol = self.getProtocol(self.url)
		protocol.progress = -1
        	
        def stopCallback(self):
		self.mediaPlayer.stop()
        	self.logo = 'logo.jpg'
        	self.gtime = False
        	self.gui.get_object('image1').set_from_stock(gtk.STOCK_MEDIA_PLAY, gtk.ICON_SIZE_BUTTON)
        	gobject.idle_add(self.statusbar, _('Stopped'))
        	self.gui.get_object('label36').set_text('00:00:00')
        	self.gui.get_object('label83').set_text('00:00:00')
        	self.name = None
        	if hasattr(self, 'url'):
			protocol = self.getProtocol(self.url)
			protocol.progress = -1
        
        def getTime(self):
        	counter = 0
        	while self.gtime:
        		if not self.paused:
				if not self.mediaPlayer.getStatus():
					self.playerError()
					return
				counter = counter + 1
				current = time.strftime('%H:%M:%S', time.gmtime(counter))
				gobject.idle_add(self.gui.get_object('label36').set_text, str(current))
				gobject.idle_add(self.gui.get_object('label83').set_text, str(current))
        		time.sleep(1)
        
        def fullscreen(self, obj, event=None):
        	if event:
			if event.button == 1 and event.type == gtk.gdk._2BUTTON_PRESS:
				self.switch_fullscreen(obj)
			elif event.button == 3:
				self.gui.get_object('menu5').popup(None, None, None, event.button, event.time)
			elif event.button == 2:
				self.remoteOK()
				
		else:
			self.switch_fullscreen(obj)
        		
        def switch_fullscreen(self, obj):
        	if self.radioMode:
        		return
        	if not self.settingsManager.getInternal():
        		return
        	if not self.isFullscreen:
        		self.gui.get_object('checkmenuitem1').set_active(True)
        		self.gui.get_object('menuitem9').set_active(True)
			self.gui.get_object('menubar1').hide()
			#self.gui.get_object('notebook2').hide()
			self.gui.get_object('hbox1').hide()
			self.gui.get_object('vbox27').hide()
			self.gui.get_object('hbox32').hide()
			self.gui.get_object('hseparator1').hide()
			self.gui.get_object('window1').fullscreen()
			self.cursorTimeout = gobject.timeout_add(2000, self.hide, obj)
			self.isFullscreen = True
		else:
			self.gui.get_object('checkmenuitem1').set_active(False)
			self.gui.get_object('menuitem9').set_active(False)
			self.gui.get_object('window1').unfullscreen()
			self.gui.get_object('window1').show_all()
			self.channelList(self.gui.get_object('menuitem7'))
			self.gui.get_object('progressbar2').hide()
			self.gui.get_object('hbox14').hide()
			self.gui.get_object('vbox18').hide()
			self.isFullscreen = False
			
	def channelList(self, obj):
		if self.gui.get_object('radiobutton1').get_active():
			if obj.get_active():
				self.gui.get_object('vbox27').show()
			else:
				self.gui.get_object('vbox27').hide()
		else:
			self.gui.get_object('notebook2').show()
			
	def hideCursor(self, obj, event):
		obj.window.set_cursor(None)
		self.cursorTimeout = gobject.timeout_add(2000, self.hide, obj)
	
	def hide(self, obj):
		pixmap = gtk.gdk.Pixmap(None, 1, 1, 1)
		color = gtk.gdk.Color()
		invisible = gtk.gdk.Cursor(pixmap, pixmap, color, color, 0, 0)
		self.gui.get_object('eventbox1').window.set_cursor(invisible)
		return False
        	
        def playpause(self, obj):
        	if self.mediaPlayer.isPlaying():
        		self.mediaPlayer.pause()
			if not self.paused:
				self.gui.get_object('image1').set_from_stock(gtk.STOCK_MEDIA_PLAY, gtk.ICON_SIZE_BUTTON)
				self.paused = True
			else:
				self.gui.get_object('image1').set_from_stock(gtk.STOCK_MEDIA_PAUSE, gtk.ICON_SIZE_BUTTON)
				self.paused = False
		else:
			page = self.gui.get_object('notebook2').get_current_page()
			if page == 0:
				chList = self.gui.get_object('treeview1')
				treeselection = chList.get_selection()
				selected = treeselection.get_selected()
				if selected[1]:
					self.playChannel(selected)
				else:
					model = chList.get_model()
					iter = model.get_iter_root()
					treeselection = chList.get_selection()
					treeselection.select_iter(iter)
					selected = treeselection.get_selected()
					self.playChannel(selected)
			elif page == 1:
				chList = self.gui.get_object('treeview3')
				treeselection = chList.get_selection()
				selected = treeselection.get_selected()
				if selected[1]:
					self.playRadioChannel(selected)
				else:
					model = chList.get_model()
					iter = model.get_iter_root()
					treeselection = chList.get_selection()
					treeselection.select_iter(iter)
					selected = treeselection.get_selected()
					self.playRadioChannel(selected)
	
	def setVolume(self, obj, value, step=0):
		if step == 0:
			self.mediaPlayer.volume(value)
			self.gui.get_object('volumebutton1').set_value(value)
			self.gui.get_object('volumebutton2').set_value(value)
		else:
			value = self.gui.get_object('volumebutton1').get_value() + step
			if value > 100.0:
				value = 100.0
			if value < 0.0:
				value = 0.0
			self.mediaPlayer.volume(value)
			self.gui.get_object('volumebutton1').set_value(value)
			self.gui.get_object('volumebutton2').set_value(value)
	
	def aspectRatio(self, obj):
		activ = obj.get_child().get_label()
		if activ == '1:1':
			self.mediaPlayer.setRatio(1)
			self.gui.get_object('aspectframe1').set(0.5, 0.5, 1, False)
			self.settingsManager.saveAspect(activ)
		elif activ == '3:2':
			self.mediaPlayer.setRatio(1.5)
			self.gui.get_object('aspectframe1').set(0.5, 0.5, 1.5, False)
			self.settingsManager.saveAspect(activ)
		elif activ == '4:3':
			self.mediaPlayer.setRatio(1.33)
			self.gui.get_object('aspectframe1').set(0.5, 0.5, 1.33, False)
			self.settingsManager.saveAspect(activ)
		elif activ == '5:4':
			self.mediaPlayer.setRatio(1.25)
			self.gui.get_object('aspectframe1').set(0.5, 0.5, 1.25, False)
			self.settingsManager.saveAspect(activ)
		elif activ == '14:9':
			self.mediaPlayer.setRatio(1.55)
			self.gui.get_object('aspectframe1').set(0.5, 0.5, 1.55, False)
			self.settingsManager.saveAspect(activ)
		elif activ == '14:10':
			self.mediaPlayer.setRatio(1.4)
			self.gui.get_object('aspectframe1').set(0.5, 0.5, 1.4, False)
			self.settingsManager.saveAspect(activ)
		elif activ == '16:9':
			self.mediaPlayer.setRatio(1.77)
			self.gui.get_object('aspectframe1').set(0.5, 0.5, 1.77, False)
			self.settingsManager.saveAspect(activ)
		elif activ == '16:10':
			self.mediaPlayer.setRatio(1.6)
			self.gui.get_object('aspectframe1').set(0.5, 0.5, 1.6, False)
			self.settingsManager.saveAspect(activ)
		elif activ == '2.35:1':
			self.mediaPlayer.setRatio(2.35)
			self.gui.get_object('aspectframe1').set(0.5, 0.5, 2.35, False)
			self.settingsManager.saveAspect(activ)
	
	def nextChannel(self, obj=None):
		page = self.gui.get_object('notebook2').get_current_page()
		if page == 0:
			chList = self.gui.get_object('treeview1')
		elif page == 1:
			chList = self.gui.get_object('treeview3')
		treeselection = chList.get_selection()
		(model, iter) = treeselection.get_selected()
		if iter:
			newiter = model.iter_next(iter)
		else:
			newiter = model.get_iter_root()
		if newiter:
			treeselection.select_iter(newiter)
			selected = treeselection.get_selected()
		else:
			iter = model.get_iter_root()
			treeselection.select_iter(iter)
			selected = treeselection.get_selected()
		if page == 0:
			self.playChannel(selected)
		elif page == 1:
			self.playRadioChannel(selected)
		
	def prevChannel(self, obj=None):
		page = self.gui.get_object('notebook2').get_current_page()
		if page == 0:
			chList = self.gui.get_object('treeview1')
		elif page == 1:
			chList = self.gui.get_object('treeview3')
		treeselection = chList.get_selection()
		(model, iter) = treeselection.get_selected()
		if iter:
			path = model.get_path(iter)
			row = path[0]
			if row > 0:
				prev_row = row - 1
				prev_iter = model.get_iter(prev_row)
				treeselection.select_iter(prev_iter)
				selected = treeselection.get_selected()
				if page == 0:
					self.playChannel(selected)
				elif page == 1:
					self.playRadioChannel(selected)
			else:
				iter = model.get_iter_root()
				while iter:
					lastIter = iter
					iter = model.iter_next(iter)
				treeselection.select_iter(lastIter)
				selected = treeselection.get_selected()
			
		
	def mute(self):
		if self.gui.get_object('volumebutton1').get_value() != 0:
			self.lastVolume = self.gui.get_object('volumebutton1').get_value()
			self.mediaPlayer.volume(0)
			self.gui.get_object('volumebutton1').set_value(0)
			self.gui.get_object('volumebutton2').set_value(0)
		else:
			self.mediaPlayer.volume(self.lastVolume)
			self.gui.get_object('volumebutton1').set_value(self.lastVolume)
			self.gui.get_object('volumebutton2').set_value(self.lastVolume)
			
	def showEPG(self):
		try:
			self.tvguide.getCurrent(self.chid, self.displayEPG)	
		except:
			pass
		
	def displayEPG(self, nowontv, channelName = None):
        	if nowontv:
			self.mediaPlayer.OSD(self.name + '\n' + nowontv)
	        else:
	        	self.mediaPlayer.OSD(self.name)
		return False
				
        def statusbar(self, message, percent=None):
        	self.gui.get_object('label65').set_text(message)
        	self.gui.get_object('label80').set_text(message)
        	self.gui.get_object('statusicon1').set_tooltip_text(message)
        	if percent:
        		try:
        			if percent == -1:
        				self.gui.get_object('progressbar2').hide()
        			else:
	        			r = float(percent)/float(100)
					self.gui.get_object('progressbar2').set_fraction(r)
					self.gui.get_object('progressbar2').show()
	        		if r >= 1.0:
	        			gobject.timeout_add(1000, self.resetStatusbar)
	        	except:
	        		self.gui.get_object('progressbar2').set_fraction(0.0)
	        		
	def updateProgressbar(self, protocol):
		if protocol == None:
			print 'protocol none'
			self.gui.get_object('progressbar2').hide()
			return False
		percent = protocol.progress
		if percent == -1:
			self.gui.get_object('progressbar2').hide()
			return False
		if percent == 0:
			self.gui.get_object('progressbar2').pulse()
			self.gui.get_object('progressbar2').show()
			return True
		r = float(percent)/float(100)
		self.gui.get_object('progressbar2').set_fraction(r)
		self.gui.get_object('progressbar2').show()
		return True
	
	def resetStatusbar(self):
		self.gui.get_object('label65').set_text('')
		self.gui.get_object('progressbar2').set_fraction(0)
		self.gui.get_object('progressbar2').hide()
		return False	
        	
        def mainWindowsKeyRelease(self, obj, event):
        	if self.isFullscreen and event.keyval == 65307:
        		self.switch_fullscreen(obj)
        	if event.keyval == 109:
			self.mute()
		if self.isFullscreen and event.keyval == 65362:
			self.remoteUP()
		if self.isFullscreen and event.keyval == 65364:
			self.remoteDOWN()
		if self.isFullscreen and event.keyval == 65293:
			self.remoteOK()
		if self.isFullscreen and event.keyval == 65481:
			self.showEPG()
	
	def mouseRemote(self, obj, event):
		if event.direction.value_name == 'GDK_SCROLL_DOWN':
			self.remoteDOWN()
		elif event.direction.value_name == 'GDK_SCROLL_UP':
			self.remoteUP()
        	
        def gtkMessage(self, tip, butoane, titlu, text):
        	gtk.gdk.threads_enter()
        	dialog = gtk.MessageDialog(parent=self.gui.get_object('window1'), flags=0, type=tip, buttons=butoane, message_format=text);
		dialog.set_title(titlu);
		resp = dialog.run();
		dialog.destroy();
		gtk.gdk.threads_leave();
		return False
	
	def showError(self, msg):
		self.gui.get_object('label31').set_text(msg)
		self.gui.get_object('window5').show()
		self.countdown = 5
		gobject.timeout_add(1000, self.error_countdown)
		
	def playerError(self):
		self.logo = 'error.jpg'
		self.stopCallback()
	
	def error_countdown(self):
		if self.countdown != 0:
			self.countdown = self.countdown - 1
			self.gui.get_object('label32').set_text('Closing in %s seconds...' % str(self.countdown))
			return True
		else:
			self.hideError()
			return False
	
	def hideError(self, obj=None):
		self.gui.get_object('window5').hide()
		self.gui.get_object('label32').set_text('Closing in 5 seconds...')
		
	def showGhidTV(self, obj, chname=None):
		try:
			self.gui.get_object('combobox2').disconnect(self.combobox2h)
			self.gui.get_object('combobox3').disconnect(self.combobox3h)
		except:
			pass
		romana =[_('Sunday'), _('Monday'), _('Tuesday'), _('Wednesday'), _('Thursday'), _('Friday'), _('Saturday')]
		now = datetime.datetime.now()
		if now.hour < 6:
			today = datetime.date.today() - datetime.timedelta(1)
		else:
			today = datetime.date.today()
		self.gui.get_object('liststore3').clear()
		for x in range(0, 7):
			zile = datetime.timedelta(days=x)
			zinoua = today + zile
			nrzi = int(zinoua.strftime("%w"))
			zinouaday = str(zinoua.day)
			lunanoua = str(zinoua.month)
			if len(zinouaday) == 1:
				zinouaday = '0' + zinouaday
			if len(lunanoua) == 1:
				lunanoua = '0' + lunanoua
			datanoua = zinouaday + '.' + lunanoua + '.' +  str(zinoua.year)
			iter = self.gui.get_object('liststore3').append([romana[nrzi] + ', ' + datanoua, datanoua.replace('.', '-')])
			if x == 0:
				self.gui.get_object('combobox3').set_active_iter(iter)
		self.gui.get_object('scrolledwindow4').hide()
		self.gui.get_object('liststore4').clear()
		self.gui.get_object('image5').clear()
		treeselection = self.gui.get_object('treeview1').get_selection()
		(model, iter) = treeselection.get_selected()
		self.gui.get_object('combobox2').set_active_iter(iter)
		timp = self.gui.get_object('liststore3').get_value(self.gui.get_object('combobox3').get_active_iter(), 1)
		if not chname:
			chname = self.gui.get_object('treestore2').get_value(self.gui.get_object('combobox2').get_active_iter(), 3)
		threading.Thread(target=self.tvguide.getGuideData, args=(timp, chname, self.fillGhidTV)).start()
		self.gui.get_object('window4').show()
		self.gui.get_object('window4').present()
		self.combobox2h = self.gui.get_object('combobox2').connect('changed', self.updateEPG)
		self.combobox3h = self.gui.get_object('combobox3').connect('changed', self.updateEPG)
		
	def fillGhidTV(self, data, none=None):
		model = self.gui.get_object('liststore4')
		if data:
			for x in data:
				model.append(x)
				
	def pgDetails(self, obj, event=None):
		self.gui.get_object('image5').clear()
		self.gui.get_object('scrolledwindow4').hide()
		treeselection = self.gui.get_object('treeview2').get_selection()
		(model, iter) = treeselection.get_selected()
		url = model.get_value(iter, 2)
		threading.Thread(target=self.tvguide.getPgDetails, args=(url, self.showpgDetails)).start()
		
	def showpgDetails(self, data, data_url):
		treeselection = self.gui.get_object('treeview2').get_selection()
		(model, iter) = treeselection.get_selected()
		url = model.get_value(iter, 2)
		if url != data_url:
			return
		if data:
			self.gui.get_object('label30').set_text(data[1])
			self.gui.get_object('label29').set_text(data[3])
			self.gui.get_object('label28').set_markup(data[2].replace('[BR]', '\n'))
			if data[0]:
				loader = gtk.gdk.PixbufLoader()
				loader.write(data[0])
				loader.close()
				self.gui.get_object('image5').set_from_pixbuf(loader.get_pixbuf())
			self.gui.get_object('scrolledwindow4').show()
		else:
			self.gui.get_object('scrolledwindow4').hide()
		
	def hideGhidTV(self, obj, event=None):
		self.gui.get_object('window4').hide()
		return True
		
	def updateEPG(self, obj=None):
		try:
			self.gui.get_object('scrolledwindow4').hide()
			self.gui.get_object('liststore4').clear()
			self.gui.get_object('image5').clear()
			timp = self.gui.get_object('liststore3').get_value(self.gui.get_object('combobox3').get_active_iter(), 1)
			chname = self.gui.get_object('treestore2').get_value(self.gui.get_object('combobox2').get_active_iter(), 3)
			threading.Thread(target=self.tvguide.getGuideData, args=(timp, chname, self.fillGhidTV)).start()
		except Exception, e:
			pass
		
	def remoteUP(self):
		if self.hideTimeout:
			gobject.source_remove(self.hideTimeout)
		page = self.gui.get_object('notebook2').get_current_page()
		if page == 0:
			chList = self.gui.get_object('treeview1')
		elif page == 1:
			chList = self.gui.get_object('treeview3')
		elif page == 2:
			return
		treeselection = chList.get_selection()
		(model, iter) = treeselection.get_selected()
#		name = model.get_value(iter, 1)
#		if name == 'TV-MAXE' or name == 'PBX TV':
#			path = model.get_path(iter)
#			chList.expand_row(path, False)
#			iter = model.iter_next(iter)
		if iter:
			path = model.get_path(iter)
			row = list(path)
			newlast = row[len(row)-1]-1
			if newlast < 0:
				row.pop()
			else:
				row[len(row)-1] = newlast
			row = tuple(row)
			if len(row) != 0:
				if row > 0:
					prev_row = row
					if prev_row > 0:
						prev_iter = model.get_iter(prev_row)
						treeselection.select_iter(prev_iter)
						selected = treeselection.get_selected()
		else:
			iter = model.get_iter_root()
			if iter:
				treeselection.select_iter(iter)
			else:
				return
		page = self.gui.get_object('notebook2').get_current_page()
		if page == 0:
			chList = self.gui.get_object('treeview1')
		elif page == 1:
			chList = self.gui.get_object('treeview3')
		treeselection = chList.get_selection()
		(model, iter) = treeselection.get_selected()
		self.gui.get_object('image9').set_from_pixbuf(model.get_value(iter, 0))
		self.gui.get_object('label39').set_text(model.get_value(iter, 1))
		if model.get_value(iter, 1) == 'TV-MAXE' or model.get_value(iter, 1) == 'PBX TV':
			self.gui.get_object('label40').set_text(_("Channels: ") + str(model.iter_n_children(iter)))
		else:
			self.gui.get_object('label40').set_text(_("Press OK or middle-click to play this channel"))
		self.gui.get_object('label63').set_text('')
		try:
			if model.get_value(iter, 3) != '':
				self.tvguide.getCurrent(model.get_value(iter, 3), self.label63)
		except:
			pass
		self.gui.get_object('vbox18').show()
		self.hideTimeout = gobject.timeout_add(4000, self.hidev18)
	
	def remoteDOWN(self):
		if self.hideTimeout:
			gobject.source_remove(self.hideTimeout)
		page = self.gui.get_object('notebook2').get_current_page()
		if page == 0:
			chList = self.gui.get_object('treeview1')
		elif page == 1:
			chList = self.gui.get_object('treeview3')
		elif page == 2:
			return
		treeselection = chList.get_selection()
		(model, iter) = treeselection.get_selected()
		if not iter:
			iter = model.get_iter_root()
		name = model.get_value(iter, 1)
		if name == 'TV-MAXE' or name == 'PBX TV':
			path = model.get_path(iter)
			chList.expand_row(path, False)
		if iter:
			name = model.get_value(iter, 1)
			if name == 'TV-MAXE' or name == 'PBX TV':
				print 'depth'
				newiter = model.iter_nth_child(iter, 0)
			else:
				newiter = model.iter_next(iter)
			if newiter:
				treeselection.select_iter(newiter)
				selected = treeselection.get_selected()
			else:
				if model.iter_depth(iter) == 1:
					parent = model.iter_parent(iter)
					if model.iter_next(parent):
						treeselection.select_iter(model.iter_next(parent))
					else:
						treeselection.select_iter(model.get_iter_root())
		else:
			iter = model.get_iter_root()
			if iter:
				treeselection.select_iter(iter)
			else:
				return
		page = self.gui.get_object('notebook2').get_current_page()
		if page == 0:
			chList = self.gui.get_object('treeview1')
		elif page == 1:
			chList = self.gui.get_object('treeview3')
		treeselection = chList.get_selection()
		(model, iter) = treeselection.get_selected()
		self.gui.get_object('image9').set_from_pixbuf(model.get_value(iter, 0))
		self.gui.get_object('label39').set_text(model.get_value(iter, 1))
		if model.get_value(iter, 1) == 'TV-MAXE' or model.get_value(iter, 1) == 'PBX TV':
			self.gui.get_object('label40').set_text(_("Channels: ") + str(model.iter_n_children(iter)))
		else:
			self.gui.get_object('label40').set_text(_("Press OK or middle-click to play this channel"))
		self.gui.get_object('label63').set_text('')
		try:
			if model.get_value(iter, 3) != '':
				self.tvguide.getCurrent(model.get_value(iter, 3), self.label63)
		except:
			pass
		self.gui.get_object('vbox18').show()
		self.hideTimeout = gobject.timeout_add(4000, self.hidev18)
		
	def label63(self, data, channelName):
		if data:
			page = self.gui.get_object('notebook2').get_current_page()
			if page == 0:
				chList = self.gui.get_object('treeview1')
			elif page == 1:
				chList = self.gui.get_object('treeview3')
			treeselection = chList.get_selection()
			(model, iter) = treeselection.get_selected()
			try:
				if model.get_value(iter, 3) != '':
					if model.get_value(iter, 3) == channelName:
						self.gui.get_object('label63').set_text(data)
			except:
				pass
		
	def remoteOK(self):
		chList = self.gui.get_object('treeview1')
		treeselection = chList.get_selection()
		(model, iter) = treeselection.get_selected()
		if iter:
			if self.name == model.get_value(iter, 1):
				self.hidev18()
				return
		if not self.gui.get_object('vbox18').props.visible:
			self.hidev18()
			return
		self.hidev18()
		self.playChannel((model, iter))
		
	def hidev18(self, iter=None):
		self.gui.get_object('vbox18').hide()
		if iter:
			pass
		return False
		
	def ShowDetails(self, obj, event=None):
		treeselection = self.gui.get_object('treeview4').get_selection()
		(model, iter) = treeselection.get_selected()
		description = model.get_value(iter, 2);
		photo = model.get_value(iter, 3);
		name = model.get_value(iter, 0);
		self.gui.get_object('label45').set_text(name)
		self.gui.get_object('label46').set_text(description)
		threading.Thread(target=self.downloadShowImage, args=(photo, )).start()
		self.gui.get_object('window6').set_title('Detalii: ' + name)
		self.gui.get_object('image10').hide()
		self.gui.get_object('window6').show()
		
	def downloadShowImage(self, url):
		req = urllib2.Request(url)
		response = urllib2.urlopen(req)
		imgdata = response.read()
		gobject.idle_add(self.loadImage_n_ShowDetails, imgdata)
		
	def loadImage_n_ShowDetails(self, imgdata):
		loader = gtk.gdk.PixbufLoader()
        	loader.write(imgdata)
        	loader.close()
        	self.gui.get_object('image10').set_from_pixbuf(loader.get_pixbuf())
        	self.gui.get_object('image10').show()
        	
        def hideShowDetails(self, obj, event=None):
        	self.gui.get_object('window6').hide()
        	return True
		
	def showAbout(self, obj):
		self.gui.get_object('aboutdialog1').show()
		
	def hideAbout(self, obj, event=None):
		self.gui.get_object('aboutdialog1').hide()
		return True
	
	def tabSwitch(self, obj, pointer, page):
		self.gui.get_object('imagemenuitem1').show()
		if page == 0: #la selectarea primului tab
			self.gui.get_object('imagemenuitem1').set_label(_('Add a TV channel'))
		if page == 1: #la selectarea celui de-al doilea tab
			self.gui.get_object('imagemenuitem1').set_label(_('Add a Radio channel'))
		if page == 2: #la selectarea celui de-al treilea tab
			self.gui.get_object('imagemenuitem1').hide()
	
	def refreshList(self, obj, event=None):
		self.gui.get_object('treestore2').clear()
		self.gui.get_object('treestore3').clear()
		threading.Thread(target=self.getChannels, args=(self.populateList,)).start()
		
	def showVideoEQ(self, obj, event=None):
		self.gui.get_object('window8').show()
		self.gui.get_object('window8').present()
		
	def hideVideoEQ(self, obj, event=None):
		self.gui.get_object('window8').hide()
		return True
		
	def videoEQreset(self, obj, event=None):
		self.gui.get_object('vscale1').set_value(0)
		self.gui.get_object('vscale2').set_value(0)
		self.gui.get_object('vscale3').set_value(0)
		
	def applyContrast(self, obj, event=None):
		b = self.gui.get_object('vscale1').get_value()
		c = self.gui.get_object('vscale2').get_value()
		s = self.gui.get_object('vscale3').get_value()
		self.mediaPlayer.adjustImage(b, c, s)
		
	def saveContrast(self, obj, event=None):
		b = self.gui.get_object('vscale1').get_value()
		c = self.gui.get_object('vscale2').get_value()
		s = self.gui.get_object('vscale3').get_value()
		self.mediaPlayer.adjustImage(b, c, s)
		self.settingsManager.saveContrast(b, c, s)
		self.gui.get_object('window8').hide()
		
	def setContrast(self):
		values = self.settingsManager.getContrast()
		self.gui.get_object('vscale1').set_value(values['b'])
		self.gui.get_object('vscale2').set_value(values['c'])
		self.gui.get_object('vscale3').set_value(values['s'])
		
	def initContrast(self):
		self.applyContrast(None)
		if int(time.time()) > self.initialTime + 5:
			return False
		else:
			return True
		
	def showAddStream(self, obj, event=None):
		self.gui.get_object('window7').show()
		
	def hideAddStream(self, obj, event=None):
		self.gui.get_object('window7').hide()
		return True
	
	def addNewChannel(self, obj, event=None):
		page = self.gui.get_object('notebook2').get_current_page()
		image = gtk.gdk.pixbuf_new_from_file('blank.gif')
		nume = self.gui.get_object('entry3').get_text()
		url = self.gui.get_object('entry4').get_text()
		chfile = open(os.getenv('HOME') + '/.tvmaxe/tvmaxe_ch', 'a')
		if page == 0:
			channelstore = self.gui.get_object('treestore2')
			iter = channelstore.get_iter_root()
			while (iter):
				if url == channelstore.get_value(iter, 2):
					dialog = gtk.MessageDialog(parent=self.gui.get_object('window7'), flags=0, type=gtk.MESSAGE_ERROR, buttons=gtk.BUTTONS_CLOSE, message_format=_('This channel already exists'));
					dialog.set_title(_('Error'));
					resp = dialog.run();
					dialog.destroy();
					return
				iter = channelstore.iter_next(iter)
			if nume == '' or url == '':
				dialog = gtk.MessageDialog(parent=self.gui.get_object('window1'), flags=0, type=gtk.MESSAGE_ERROR, buttons=gtk.BUTTONS_CLOSE, message_format=_('Name and URL required!'));
				dialog.set_title(_('Error'));
				resp = dialog.run();
				dialog.destroy();
				return
			url = url.translate(string.maketrans("", ""), string.whitespace)
			channelstore.append(None, [image, nume, url, '', 'Local'])
			chfile.write('TV|-|' + nume + '|-|' + url + '\n')
		if page == 1:
			channelstore = self.gui.get_object('treestore3')
			iter = channelstore.get_iter_root()
			while (iter):
				if url == channelstore.get_value(iter, 2):
					dialog = gtk.MessageDialog(parent=self.gui.get_object('window7'), flags=0, type=gtk.MESSAGE_ERROR, buttons=gtk.BUTTONS_CLOSE, message_format=_('This channel already exists'));
					dialog.set_title(_('Error'));
					resp = dialog.run();
					dialog.destroy();
					return
				iter = channelstore.iter_next(iter)
			channelstore.append(None, [image, nume, url, 'Local'])
			chfile.write('RA|-|' + nume + '|-|' + url + '\n')
		if not 'local://' in self.settingsManager.subscriptions:
			self.settingsManager.enableLocalChList()		# activeaza lista locala de canale
		chfile.close()

		#self.gui.get_object('treeviewcolumn2').clicked()
		#self.gui.get_object('treeviewcolumn6').clicked()
		self.gui.get_object('entry3').set_text('')
		self.gui.get_object('entry4').set_text('')
		self.gui.get_object('window7').hide()
		
	def deleteChannel(self, obj, event=None):
		page = self.gui.get_object('notebook2').get_current_page()
		if page == 0:
			chList = self.gui.get_object('treeview1')
			treeselection = chList.get_selection()
			(model, iter) = treeselection.get_selected()
			url = model.get_value(iter, 2)
			model.remove(iter)
		elif page == 1:
			chList = self.gui.get_object('treeview3')
			treeselection = chList.get_selection()
			(model, iter) = treeselection.get_selected()
			url = model.get_value(iter, 2)
			model.remove(iter)
		else:
			pass
		self.settingsManager.addToBlackist(url)
		
	def loginPBX(self, obj, auto = False):
		pbxlogin = self.settingsManager.getPBXuser()
		self.gui.get_object('entry5').set_text(pbxlogin[1])
		self.gui.get_object('entry6').set_text(pbxlogin[2])
		self.gui.get_object('checkbutton3').set_active(pbxlogin[0])
		self.gui.get_object('window9').show()
		if auto:
			self.connectPBX(self.gui.get_object('button32'))
		return False
		
	def hidePBX(self, obj, event=None):
		if not self.gui.get_object('checkbutton3').get_active():
			self.gui.get_object('entry5').set_text('')
			self.gui.get_object('entry6').set_text('')
			self.settingsManager.savePBX(self.gui.get_object('checkbutton3').get_active(), self.gui.get_object('entry5').get_text(), self.gui.get_object('entry6').get_text())
		else:
			self.settingsManager.savePBX(self.gui.get_object('checkbutton3').get_active(), self.gui.get_object('entry5').get_text(), self.gui.get_object('entry6').get_text())
		self.gui.get_object('window9').hide()
		return True

	def PBXupdateBar(self):
		print 'update'
		if self.pbx.nrCanale == 0:
			return True		# reapeleaza functia
		frac = float(self.pbx.nrIncarcate) / float(self.pbx.nrCanale)
		if frac < 1.0:
			self.gui.get_object('progressbar1').set_fraction(frac)
			return True		# reapeleaza functia
		else:
			self.gui.get_object('progressbar1').set_fraction(1.0)
			self.gui.get_object('window9').hide()
			return False		# nu mai reapela
		
	def connectPBX(self, obj, event=None):
		username = self.gui.get_object('entry5').get_text()
		password = self.gui.get_object('entry6').get_text()
		threading.Thread(target=self.pbx.signIn, args=(username, password, self.getPBX)).start()
		self.gui.get_object('vbox26').set_sensitive(False)
		self.gui.get_object('hbox27').show()
		self.PBXupdateBar_to = gobject.timeout_add(500, self.PBXupdateBar)
		
	def getPBX(self, chlist):
		if not chlist:
			if hasattr(self, 'PBXupdateBar_to'):
				gobject.source_remove(self.PBXupdateBar_to)
			gobject.idle_add(self.gtkMessage, gtk.MESSAGE_ERROR, gtk.BUTTONS_CLOSE, _('Error'), _('Cannot fetch the channel list. Aborting...'))
			gobject.idle_add(self.gui.get_object('vbox26').set_sensitive, True)
			gobject.idle_add(self.gui.get_object('hbox27').hide)
			gobject.idle_add(self.gui.get_object('window9').hide)
			return
		#gtk.gdk.pixbuf_new_from_file('PBX.png')
		blacklist = self.settingsManager.getBlacklist()
		tvstore = self.gui.get_object('treestore2')
		radiostore = self.gui.get_object('treestore3')
		self.gui.get_object('treeview1').set_model(None)
		self.gui.get_object('treeview3').set_model(None)
		
		# clasificare TV
		iters = []
		iter = tvstore.get_iter_root()
		while (iter):
			iterData = [tvstore.get_value(iter, 0),
				    tvstore.get_value(iter, 1),
				    tvstore.get_value(iter, 2),
				    tvstore.get_value(iter, 3),
				    tvstore.get_value(iter, 4)]
			iters.append(iterData)
			iter = tvstore.iter_next(iter)
		tvstore.clear()
		parentIter = tvstore.append(None, [gtk.gdk.pixbuf_new_from_file('tvmaxe_mini.png'), 'TV-MAXE', '', '', 'PBX'])
		for x in iters:
			tvstore.append(parentIter, x)
			
		# clasificare Radio
		iters = []
		iter = radiostore.get_iter_root()
		while (iter):
			iterData = [radiostore.get_value(iter, 0),
				    radiostore.get_value(iter, 1),
				    radiostore.get_value(iter, 2),
				    radiostore.get_value(iter, 3)]
			iters.append(iterData)
			iter = radiostore.iter_next(iter)
		radiostore.clear()
		parentIter = radiostore.append(None, [gtk.gdk.pixbuf_new_from_file('tvmaxe_mini.png'), 'TV-MAXE', '', 'PBX'])
		for x in iters:
			radiostore.append(parentIter, x)
		
		# adaugare PBX
		parentIter_tv = tvstore.append(None, [gtk.gdk.pixbuf_new_from_file('PBX.png'), 'PBX TV', '', '', 'PBX'])
		parentIter_ra = radiostore.append(None, [gtk.gdk.pixbuf_new_from_file('PBX.png'), 'PBX TV', '', 'PBX'])
		for x in chlist:
			if not x[1] in blacklist:
				if x[0].startswith('Radio'):
					print x
					radiostore.append(parentIter_ra, [gtk.gdk.pixbuf_new_from_file('PBX.png'), x[0], x[1], 'PBX'])
				else:
					tvstore.append(parentIter_tv, [gtk.gdk.pixbuf_new_from_file('PBX.png'), x[0], x[1], '', 'PBX'])
		self.gui.get_object('treeview1').set_model(tvstore)
		self.gui.get_object('treeview3').set_model(radiostore)
		#self.gui.get_object('treeviewcolumn2').clicked()
		#self.gui.get_object('treeviewcolumn6').clicked()
		self.gui.get_object('vbox26').set_sensitive(True)
		self.gui.get_object('hbox27').hide()
		self.gui.get_object('window9').hide()
		if self.gui.get_object('checkbutton3').get_active():
			self.settingsManager.savePBX(self.gui.get_object('checkbutton3').get_active(), self.gui.get_object('entry5').get_text(), self.gui.get_object('entry6').get_text())
		else:
			self.settingsManager.savePBX(self.gui.get_object('checkbutton3').get_active(), '', '')
	
	def adaugaAbonament(self, obj=None):
		self.gui.get_object('entry7').set_text('')
		self.gui.get_object('entry8').set_text('')
		self.gui.get_object('window10').show()
	
	def addSubscription(self, obj):
		nume = self.gui.get_object('entry7').get_text()
		url = self.gui.get_object('entry8').get_text()
		self.settingsManager.abonamente[nume] = url
		self.gui.get_object('liststore1').append([False, nume, url])
		self.gui.get_object('window10').hide()
		
	def hideAdaugaAbonament(self, obj=None, event=None):
		self.gui.get_object('window10').hide()
		return True
		
	def editAbonament(self, obj):
		self.gui.get_object('entry9').set_text('')
		self.gui.get_object('entry10').set_text('')
		lista = self.gui.get_object('treeview4')
		treeselection = lista.get_selection()
		(model, iter) = treeselection.get_selected()
		if iter:
			self.lastSubEdit = model.get_value(iter, 1)
			self.lastSubURLEdit = model.get_value(iter, 2)
			self.gui.get_object('entry9').set_text(self.lastSubEdit)
			self.gui.get_object('entry10').set_text(self.lastSubURLEdit)
			self.gui.get_object('window11').show()
			
	def saveEditAbonament(self, obj):
		lista = self.gui.get_object('treeview4')
		treeselection = lista.get_selection()
		(model, iter) = treeselection.get_selected()
		nume = self.gui.get_object('entry9').get_text()
		url = self.gui.get_object('entry10').get_text()
		model.set_value(iter, 1, nume)
		model.set_value(iter, 2, url)
		if nume != self.lastSubEdit:
			self.settingsManager.abonamente[nume] = url
			del self.settingsManager.abonamente[self.lastSubEdit]
			self.lastSubEdit = None
		if url != self.lastSubURLEdit:
			self.settingsManager.subscriptions.pop(self.settingsManager.subscriptions.index(self.lastSubURLEdit))
			self.settingsManager.abonamente[nume] = url
			self.settingsManager.subscriptions.append(url)
			self.lastSubURLEdit = None
			self.settingsManager.updateList = True
		self.gui.get_object('window11').hide()
	
	def hideEditAbonament(self, obj, event=None):
		self.gui.get_object('entry9').set_text('')
		self.gui.get_object('entry10').set_text('')
		self.gui.get_object('window11').hide()
		return True
		
	def stergeAbonament(self, obj):
		lista = self.gui.get_object('treeview4')
		treeselection = lista.get_selection()
		(model, iter) = treeselection.get_selected()
		if iter:
			del self.settingsManager.abonamente[model.get_value(iter, 1)]
			try:
				self.settingsManager.subscriptions.pop(self.settingsManager.subscriptions.index(model.get_value(iter, 2)))
			except:
				pass
			model.remove(iter)
			
	def channelExists(self, url, nume, model):
		ret = False
		iter = model.get_iter_root()
		while iter:
			if model.get_value(iter, 2) == url:
				ret = True
			if model.get_value(iter, 1) == nume:
				model.set_value(iter, 2, url)
				ret = True
			iter = model.iter_next(iter)
		return ret

	def wrapDonateText(self, obj, size):
		self.gui.get_object('label62').set_size_request(size.width, size.height)

	def findKey(self, dic, val):
		try:
			return [k for k, v in dic.iteritems() if v == val][0]
		except:
			return None
	
	def donate(self, obj, event=None):
		webbrowser.open('https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=DZ52GUL3WXQKN&lc=RO&item_name=TV%2dMAXE&no_note=1&no_shipping=1&currency_code=EUR&bn=PP%2dDonationsBF%3abtn_donateCC_LG%2egif%3aNonHosted')
		self.donated(None)
		
	def donated(self, obj, event=None):
		ver = self.settingsManager.saveDonate(version)
		self.gui.get_object('hbox29').hide()
		
	def showDonate(self):
		v = self.settingsManager.getDonate()
		if float(v) < float(version):
			self.gui.get_object('hbox29').show()
			
	def hideShowTVMaxe(self, obj, event=None):
		if event.button == 1:
			if self.tvmaxevis:
				if self.radioMode:
					self.gui.get_object('window13').hide()
				else:
					self.gui.get_object('window1').hide()
				self.gui.get_object('menuitem29').set_label(_('Show TV-MAXE'))
				self.tvmaxevis = False
			else:
				if self.radioMode:
					self.gui.get_object('window13').show()
				else:
					self.gui.get_object('window1').show()
				self.gui.get_object('menuitem29').set_label(_('Hide TV-MAXE'))
				self.tvmaxevis = True
		if event.button == 3:
			if self.mediaPlayer.isPlaying():
				self.gui.get_object('menuitem30').set_sensitive(True)
			else:
				self.gui.get_object('menuitem30').set_sensitive(False)
			self.gui.get_object('menu9').popup(None, None, gtk.status_icon_position_menu, event.button, event.time, self.gui.get_object('statusicon1'))
			
	def hideShowTVMaxe_Menu(self, obj):
		if self.tvmaxevis:
			if self.radioMode:
				self.gui.get_object('window13').hide()
			else:
				self.gui.get_object('window1').hide()
			self.gui.get_object('menuitem29').set_label(_('Show TV-MAXE'))
			self.tvmaxevis = False
		else:
			if self.radioMode:
				self.gui.get_object('window13').show()
			else:
				self.gui.get_object('window1').show()
			self.gui.get_object('menuitem29').set_label(_('Hide TV-MAXE'))
			self.tvmaxevis = True
			
	def statusIconVolume(self, obj, event):
		if event.direction.value_name == 'GDK_SCROLL_DOWN':
			gobject.idle_add(self.setVolume, None, None, -0.1)
		elif event.direction.value_name == 'GDK_SCROLL_UP':
			gobject.idle_add(self.setVolume, None, None, 0.1)
			
	def createTrayMenus(self):
		model = self.gui.get_object('treestore3')
		menu = gtk.Menu()
		iter = model.get_iter_root()
		while iter:
			nume = model.get_value(iter, 1)
			item = gtk.MenuItem(nume)
			item.show()
			item.connect("activate", self.trayplay, self.playRadioChannel, (model, iter))
			menu.append(item)
			iter = model.iter_next(iter)
		self.gui.get_object('menuitem38').remove_submenu()
		self.gui.get_object('menuitem38').set_submenu(menu)
		model = self.gui.get_object('treestore2')
		menu = gtk.Menu()
		iter = model.get_iter_root()
		while iter:
			nume = model.get_value(iter, 1)
			item = gtk.MenuItem(nume)
			item.show()
			item.connect("activate", self.trayplay, self.playChannel, (model, iter))
			menu.append(item)
			iter = model.iter_next(iter)
		self.gui.get_object('menuitem39').remove_submenu()
		self.gui.get_object('menuitem39').set_submenu(menu)
		
	def trayplay(self, obj, func, t):
		page = self.gui.get_object('notebook2').get_current_page()
		if t[0] == self.gui.get_object('treestore2'):
			chList = self.gui.get_object('treeview1')
			treeselection = chList.get_selection()
			treeselection.select_iter(t[1])
		elif t[0] == self.gui.get_object('treestore3'):
			chList = self.gui.get_object('treeview3')
			treeselection = chList.get_selection()
			treeselection.select_iter(t[1])
		func(t)
			
	def channelInfo(self, obj):
		page = self.gui.get_object('notebook2').get_current_page()
		if page == 0:
			chList = self.gui.get_object('treeview1')
			treeselection = chList.get_selection()
			selected = treeselection.get_selected()
			(model, iter) = treeselection.get_selected()
			nume = model.get_value(iter, 1)
			abonament = model.get_value(iter, 4)
			adresa = model.get_value(iter, 2)
			icon = model.get_value(iter, 0)
			if adresa.startswith('sop:'):
				protocol = 'SopCast'
			else:
				gp = adresa.split('://')
				protocol = gp[0].upper()
			valabilitate = ''
			chid = model.get_value(iter, 3)
		elif page == 1:
			chList = self.gui.get_object('treeview3')
			treeselection = chList.get_selection()
			selected = treeselection.get_selected()
			(model, iter) = treeselection.get_selected()
			nume = model.get_value(iter, 1)
			abonament = model.get_value(iter, 3)
			adresa = model.get_value(iter, 2)
			icon = model.get_value(iter, 0)
			if adresa.startswith('sop:'):
				protocol = 'SopCast'
			else:
				gp = adresa.split('://')
				protocol = gp[0].upper()
			valabilitate = ''
			chid = ''
		if chid != '':
			self.gui.get_object('button43').set_sensitive(True)
		else:
			self.gui.get_object('button43').set_sensitive(False)
		self.gui.get_object('button42').set_sensitive(True)
		self.gui.get_object('button42').set_label(_('Report as broken'))
		self.gui.get_object('image22').set_from_pixbuf(icon)
		self.gui.get_object('label59').set_label(nume)
		self.gui.get_object('label72').set_label(abonament)
		self.gui.get_object('label74').set_label(protocol)
		self.gui.get_object('label76').set_label(adresa)
		self.gui.get_object('label78').set_label('')
		self.gui.get_object('window12').show()
		threading.Thread(target=self.valabilitate, args=(adresa, self.channelInfo_status)).start()
		
	def channelInfo_status(self, status):
		self.gui.get_object('label78').set_label(status)
		return False
	
	def hideChannelInfo(self, obj, event=None):
		self.gui.get_object('window12').hide()
		return True
		
	def channelInfo_showGhidTV(self, obj):
		self.showGhidTV(None, self.gui.get_object('label59').get_label())
		self.updateEPG(None)
		
	def valabilitate(self, url, callback):
		try:
			req = urllib2.Request(basehost + '/report.php?get=' + url)
			response = urllib2.urlopen(req)
			data = int(response.read())
			if data > 5:
				idle = gobject.idle_add(callback, '<span foreground="#FF0000">' + _('appears to be broken') + '</span>')
			else:
				idle = gobject.idle_add(callback, 'OK')
		except:
			idle = gobject.idle_add(callback, 'OK')
			
	def channelInfo_raporteaza(self, obj):
		obj.set_label(_('Reported'))
		obj.set_sensitive(False)
		threading.Thread(target=self.reportChannel, args=(self.gui.get_object('label76').get_label(),)).start()

	def reportChannel(self, url):
		try:
			req = urllib2.Request(basehost + '/report.php?set=' + url)
			response = urllib2.urlopen(req)
			print response.read()
		except:
			pass
	
	def getChannelList(self):
		l = {}
		model = self.gui.get_object('treestore2')
		iter = model.get_iter_root()
		while iter:
			nume = model.get_value(iter, 1)
			url = model.get_value(iter, 2)
			l[url] = nume
			iter = model.iter_next(iter)
		model = self.gui.get_object('treestore3')
		iter = model.get_iter_root()
		while iter:
			nume = model.get_value(iter, 1)
			url = model.get_value(iter, 2)
			l[url] = nume
			iter = model.iter_next(iter)
		return l

	def listError(self):
		self.gtkMessage(gtk.MESSAGE_ERROR, gtk.BUTTONS_CLOSE, _('Error'), _('Cannot fetch the channel list. Aborting...'))
			
        def quit(self, obj=None, event=None):
        	self.gtime = False
        	self.mediaPlayer.quit()
        	if hasattr(self, 'infrared'):
	        	self.infrared.quit()
	        for x in self.protocols:
			self.protocols[x].quit()
        	sizes = self.gui.get_object('window1').get_size()
        	self.settingsManager.saveWindowSize(sizes[0], sizes[1])
        	self.settingsManager.saveSubscriptions()
        	hpaned = self.gui.get_object('hpaned1').get_position()
        	self.settingsManager.saveHPanedPosition(hpaned)
        	self.settingsManager.saveVolume()
        	os._exit(0)

	def main(self):
		gtk.gdk.threads_enter()
		gtk.main()
		gtk.gdk.threads_leave()
		
if __name__ == "__main__":
    	main = Main()
    	main.main()
